
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"

#define GOTO(x,y) lcd_goto_xy_exact((x),(y))

#define LIMITA_BARA_X 66
#define LIMITA_BARA_Y  6
#define LIMITA_MINGE_X 76
#define LIMITA_MINGE_Y  7
#define SPEED_BARA 5
#define SPEED_MINGE 1
#define LENGTH_BRICK 12  /* o caramida ocupa 10 pixeli lungime si 8 pixeli inaltime */


#define BASE_X 20
#define NR_BRICKS 6

#define LEFT_AIR    (PINB &( 1 << (PB4) ))
#define RIGHT_AIR   (PINB &( 1 << (PB1) ))
#define LAUNCH_AIR  (PINB &( 1 << (PB0) ))

#define LIVES 3


unsigned char bara[]  = {
 0x0F , 0x0F , 0x0F , 0x0F , 0x0F ,0x0F ,  
 0x0F , 0x0F , 0x0F , 0x0F , 0x0F ,0x0F ,   
 0x0F , 0x0F , 0x0F , 0x0F , 0x0F ,0x0F 
};

unsigned char brick_tip_1[] = {
  0xAA , 0xAA , 0xAA , 0xAA , 0xAA  ,0xAA  ,
  0xAA , 0xAA , 0xAA ,  0xAA , 0xAA ,0xAA  
   
 };
 
unsigned char brick_tip_2[]  = {
  0xAA ,0x55 , 0xAA , 0x55 , 0xAA , 0x55  ,
  0xAA , 0x55 , 0xAA ,0x55 , 0xAA , 0x55
   
 };
 
unsigned char  x_minge , y_minge , isMoving  , dir_x , dir_y  ; 
int x_bara;
unsigned  char visible[NR_BRICKS] , cleared[NR_BRICKS ] ; //folosit pentru a face clear o singura data
int lives_left ;  
unsigned char won ; 

char disp[20];


void move_(void) {
	
	x_minge += dir_x * SPEED_MINGE;
	y_minge += dir_y * SPEED_MINGE;
	
	/* 
	*  detectare coliziuni 
	*/
	
	//ciocnire perete stanga
	if( x_minge  == 0 ) { 
		dir_x *= -1;
		++x_minge;
	}
	
	if ( x_minge == LIMITA_MINGE_X + 1)  {
		--x_minge;
		dir_x *= -1;
	}
	//ciocnire perete sus
	if( y_minge   == 0 ) {
		++y_minge;
		dir_y *= -1 ; 
	}	
	//ciocnire perete jos - END OF GAME
	if ( y_minge   == LIMITA_MINGE_Y ) {
		--y_minge ; 
		dir_y *= -1 ;
		--lives_left;
		
		if(lives_left) {
			lcd_clear();
			GOTO(5 ,3);
			sprintf(disp,"%i lives left",lives_left);
			isMoving = 0 ;
			lcd_str(disp , 0);
			while( LEFT_AIR);
			lcd_clear();
		
		}
	}
	
	//ciocnire bara orizontala
	if ( y_minge == LIMITA_BARA_Y - 1 && ( x_minge >= x_bara - 3  && x_minge <= x_bara + 18 ) ) {
		dir_y *= -1 ;
	}
	
	//coliziuni cu caramizile 
	
	//BRICK 1
	if ( x_minge + 3> BASE_X  && x_minge < BASE_X + LENGTH_BRICK - 3 && y_minge == 2 && visible[0] == 1 ) {
			visible[0] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X || x_minge == BASE_X + LENGTH_BRICK ) && y_minge == 2 && visible[0] == 1 ) {
			visible[0] = 0 ;
			dir_x *= -1;
	}
	
	//BRICK 2 
	if ( x_minge + 3 > BASE_X  + LENGTH_BRICK && x_minge < BASE_X + 2 * LENGTH_BRICK - 3 && y_minge == 1 && visible[1] == 1 ) {
			visible[1] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X + LENGTH_BRICK || x_minge == BASE_X + 2 * LENGTH_BRICK)  && y_minge == 1  && visible[1] == 1 ) {
			visible[1] = 0 ;
			dir_x *= -1;
	}
	
	//BRICK 3
	if ( x_minge + 3> BASE_X + 2*LENGTH_BRICK && x_minge < BASE_X + 3 * LENGTH_BRICK - 3 && y_minge == 1 && visible[2] == 1 ) {
			visible[2] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X + 2*LENGTH_BRICK || x_minge == BASE_X + 3 * LENGTH_BRICK)  && y_minge == 1  && visible[2] == 1 ) {
			visible[2] = 0 ;
			dir_x *= -1;
	}
	
	//BRICK 4
	if ( x_minge + 3> BASE_X + 3*LENGTH_BRICK && x_minge < BASE_X + 4 * LENGTH_BRICK - 3 && y_minge == 2 && visible[3] == 1 ) {
			visible[3] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X + 3*LENGTH_BRICK || x_minge == BASE_X + 4 * LENGTH_BRICK)  && y_minge == 2  && visible[3] == 1 ) {
			visible[3] = 0 ;
			dir_x *= -1;
	}
	//BRICK 5
	if ( x_minge + 3> BASE_X + LENGTH_BRICK && x_minge < BASE_X + 2 * LENGTH_BRICK - 3 && y_minge == 3 && visible[4] == 1 ) {
			visible[4] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X + LENGTH_BRICK || x_minge == BASE_X + 2 * LENGTH_BRICK)  && y_minge == 3  && visible[4] == 1 ) {
			visible[4] = 0 ;
			dir_x *= -1;
	}
	//BRICK 6
	if ( x_minge + 3> BASE_X + 2*LENGTH_BRICK && x_minge < BASE_X + 3 * LENGTH_BRICK - 3 && y_minge == 3 && visible[5] == 1 ) {
			visible[5] = 0;
			dir_y *= -1;
	}
	else if ( (x_minge + 3 == BASE_X + 2*LENGTH_BRICK || x_minge == BASE_X + 3 * LENGTH_BRICK)  && y_minge == 3  && visible[5] == 1 ) {
			visible[5] = 0 ;
			dir_x *= -1;
	}
	
}

/* functie desenare bricks */
void mediu() {
	
	if(visible[0]) {
		//brick 1
		GOTO(BASE_X,2) ; 
		lcd_raw(brick_tip_1 ,  LENGTH_BRICK);
	}
	else if ( !cleared[0] ) {
		lcd_clear_area( 2 , BASE_X , BASE_X + LENGTH_BRICK ) ;
		cleared[0] = 1;
	}
	
	if(visible[1]) {
		//brick 2
		GOTO( BASE_X + LENGTH_BRICK , 1);
		lcd_raw(brick_tip_1 ,  LENGTH_BRICK);
	}
	else if ( !cleared[1] ) {
		lcd_clear_area( 1 , BASE_X + LENGTH_BRICK , BASE_X + 2 * LENGTH_BRICK ) ;
		cleared[1] = 1;
	}
	
	if(visible[2]) {
		// brick 3
		GOTO( BASE_X + 2 * LENGTH_BRICK , 1);
		lcd_raw(brick_tip_2 ,  LENGTH_BRICK);
	}
	else if ( !cleared[2] ) {
		lcd_clear_area( 1 , BASE_X + 2 * LENGTH_BRICK , BASE_X + 3 * LENGTH_BRICK ) ;
		cleared[2] = 1;
	}
	
	if(visible[3]) {
		// brick 4
		GOTO( BASE_X + 3 * LENGTH_BRICK , 2);
		lcd_raw(brick_tip_1 ,  LENGTH_BRICK);
	}
	else if ( !cleared[3] ) {
		lcd_clear_area( 2 , BASE_X + 3* LENGTH_BRICK , BASE_X + 4 * LENGTH_BRICK ) ;
		cleared[3] = 1;
	}
	if(visible[4]) {
		//brick 5
		GOTO( BASE_X +  LENGTH_BRICK , 3);
		lcd_raw(brick_tip_2 ,  LENGTH_BRICK);
	}
	else if ( !cleared[4] ) {
		lcd_clear_area( 3 , BASE_X + LENGTH_BRICK , BASE_X + 2 * LENGTH_BRICK ) ;
		cleared[4] = 1;
	}
	
	if(visible[5]) {
		//brick 6
		GOTO( BASE_X +  2 * LENGTH_BRICK , 3);
		lcd_raw(brick_tip_1 ,  LENGTH_BRICK);
	}
	else if ( !cleared[5] ) {
		lcd_clear_area( 3 , BASE_X + 2 * LENGTH_BRICK , BASE_X + 3 * LENGTH_BRICK ) ;
		cleared[5] = 1;
	}
	
}

void init_() {
	unsigned char i ; 
	//initial fiecare caramida e vizibila
	//si nu a fost atinsa de bila
	for(i = 0 ; i < NR_BRICKS ; ++i) {
		visible[i] = 1;
		cleared[i] = 0;
	}
		
	//setez pozitia initiala bara
	x_bara = LCD_X_RES / 2 - 10;
	
	//setez stare bila
	isMoving = 0 ;
	lives_left  = LIVES ;
	won = 0 ;
	
	x_minge = x_bara + 6;
	y_minge = LIMITA_BARA_Y - 1;
}

int main(void)
{	
	unsigned char i ;
	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);
	//initializare porturi butoane
	DDRB = 0xFF;
	DDRB  &= ~(  (1<<PB0) | ( 1<<PB1) | (1<<PB4) );
	PORTB |= ( 1<<PB0) | ( 1<<PB1) | (1<<PB4);  //rez pull-up
	
	lcd_clear();
	GOTO(20,3);
	lcd_str("        " , 1);
	GOTO(20,4);
	lcd_str(" Bricks " , 1);
	GOTO(20,5);
	lcd_str("        " , 1);
	
	while ( LEFT_AIR ) ;
	lcd_clear();
	
	#if 1
    for(;;){
		init_();
		while( lives_left && !won ) {
			/* apasare buton LEFT */
			if( !LEFT_AIR ) {
				lcd_clear_line(LIMITA_BARA_Y);
				x_bara -= SPEED_BARA;
				if(x_bara < 0) 
					x_bara = 1 ;
			}
			/* apasare buton RIGHT */
			if(  !RIGHT_AIR ) {
				lcd_clear_line(LIMITA_BARA_Y);
				x_bara += SPEED_BARA;
				if(x_bara > LIMITA_BARA_X ) 
					x_bara = LIMITA_BARA_X ; 
			}
			/* apasare buton LAUNCH */
			if(  !LAUNCH_AIR  ) {
				isMoving = 1; //bila se misca
				dir_y = -1; //bila se misca in sus
				//determina directia initiala de lansare
				if (x_bara > LCD_X_RES / 2 - 6 ) { 
					dir_x = -1 ;
				}
				else {
					dir_x = 1;
				}
			}
			/*reset pozitie bila*/
			lcd_clear_area(y_minge , x_minge , x_minge + 5);
			/*bila pe bara*/
			if( !isMoving) {
				x_minge = x_bara + 6;
				y_minge = LIMITA_BARA_Y - 1;
			}
			/*bila se misca*/
			else 
				move_();
			//[1]paint mediu
			mediu();
			//[2] paint bara orizontala
			GOTO(x_bara , LIMITA_BARA_Y);
			lcd_raw(bara , 18 );
			//[3] paint minge 
			GOTO(x_minge , y_minge);
			lcd_chr('o' , 0);
			//
			GOTO(1,1);
			sprintf(disp , "%i" , lives_left);
			lcd_str(disp,0);
			if( !lives_left)  {
				won = 0 ; 
				break;
			}
			else {
				won = 1;
				for(i = 0 ; i < NR_BRICKS ; ++i) 
					if( !cleared[i] ) {
						won = 0;
						break ; 
					}
			}
			_delay_ms(2000);
		}//de la while
		lcd_clear();
		if(!won) {
			GOTO(17,4);
			lcd_str(" You Lost ",0);
		}
		else {
			GOTO(17,4);
			lcd_str(" You Won ",0);
		}
		
		while( LEFT_AIR ) ;
		
		lcd_clear();
		
		
	}
	#endif
	return 0  ;
}
